// ## Теоретический вопрос

// 1. Опишите своими словами как работает метод forEach.
//метод forEach перебирает каждый элемент массива, и с каждым элементом выполняет блок кода, который находится в теле функции. 
// 2. Как очистить массив?
// arr.splice(0, arr.length);
// 3. Как можно проверить, что та или иная переменная является массивом?
// с помощью мтода Array.isArray() - если массив, возвращает true, иначе false

// ## Задание

// Реализовать функцию фильтра массива по указанному типу данных. Задача должна быть реализована на языке javascript, без использования фреймворков и сторонник библиотек (типа Jquery).

// #### Технические требования:

// - Написать функцию `filterBy()`, которая будет принимать в себя 2 аргумента. Первый аргумент - массив, который будет содержать в себе любые данные, второй аргумент - тип данных.
// - Функция должна вернуть новый массив, который будет содержать в себе все данные, которые были переданы в аргумент, за исключением тех, тип которых был передан вторым аргументом. То есть, если передать массив ['hello', 'world', 23, '23', null], и вторым аргументом передать 'string', то функция вернет массив [23, null].

let array = ['hello', 'world', 23, '23', null, {id: 25, name: 'name'}];
console.log(array);

function filterBy(arr, typeData) {

 let newArray = arr.filter((item) => {
    return (typeof item !== typeData) 
  })
  return newArray;
}

console.log(filterBy(array, 'string'));
